#!/usr/bin/perl
# 
# library - counter utility 
# == scripted by Takuya Otani ========
# == copyright (C) SimpleBoxes 2004 ==

{
	my $aVersion_ = 0.00;
	# 
	# ver 0.00 [2004/07/01] 
}

sub sbcnt_init { # 
	my $file = shift; # ϥѥ᡼
	my $mode = '';    # ϥѥ᡼
	require 'sbtime.pl';
	require 'sbtext.pl';
	require 'sbform.pl';
	require 'sblock.pl';
	require 'sbhtml.pl';
	$gLockFile = 'cnt';
	eval {
		&sbini_read_globalconf($file);
		{ # Ķɹ
			my $conf = $gEnv{dir}{data} . $gEnv{file}{conf} . $gEnv{file}{suf};
			open(CONF,"<$conf") or die("failed opening configure file.\n");
			while (my $line = <CONF>) {
				$line =~ tr/\x0D\x0A//d;
				my ($key,$val) = split("\t",$line,2);
				$gEnv{'conf'}{$key} = $val;
			}
			close(CONF);
		}
		foreach my $conf ( keys(%{$gEnv{file}}) ) {
			next if (index($gEnv{file}{$conf},'.') > -1);
			$gEnv{file}{$conf} .= $gEnv{file}{suf};
		}
		# ǡȿ
		require 'sblang.pl';
		$gEnv{dir}{base} = $gEnv{conf}{dir_base};
		$gEnv{dir}{log}  = $gEnv{conf}{dir_log};
		$gEnv{dir}{img}  = $gEnv{conf}{dir_img};
		$gEnv{srv}{base} = $gEnv{conf}{srv_base};
		&sbcnt_initlogfile();
		&sbform_read();
		$mode = ($gIn{'disp'} eq 'on') ? 'js' : 'gif';
	};
	die("Content-Type: text/html;\n\n<pre>" . $@ . "</pre>\n") if ($@);
	return($mode);
}
sub sbcnt_initlogfile { # եν
	my $file = $gEnv{'dir'}{'base'} . $gEnv{'dir'}{'data'} . $gEnv{'file'}{'log'};
	if (!-e $file) {
		open(LOGOUT,">$file") or die($gMsg{'error'}{'file_open'} . $file);
		binmode(LOGOUT);
		print LOGOUT '0<>',"\n";
		close(LOGOUT);
		chmod(0666,$file);
	}
	return();
}
sub sbcnt_recordlog { # Ͽɹ
	my ($flag,$mode) = @_; # ϥѥ᡼
	my $count = 0;         # ϥѥ᡼
	my $file = $gEnv{'dir'}{'base'} . $gEnv{'dir'}{'data'} . $gEnv{'file'}{'log'};
	if ($mode eq 'js') {
		open(LOGIN,"<$file") or die($gMsg{'error'}{'file_open'} . $file);
		my $line = <LOGIN>;
		close(LOGIN);
		$count = (split('<>',$line))[0];
	} else {
		my $lfile = &sblock_lock() or die($gMsg{'error'}{'file_lock'} . "\n");
		eval {
			my $bgn = $gNowTime - ( $gEnv{'basic'}{'checklog'} * 24 * 3600 );
			my $tmp = '';
			my @env = &sbhtml_gethost(); # $host,$addr,$refe,$agnt
			my @buf = ();
			open(LOGIN,"<$file") or die($gMsg{'error'}{'file_open'} . $file);
			$tmp = <LOGIN>;
			while (my $line = <LOGIN>) {
				my @elem = split('<>',$line);
				push(@buf,$line) if ($elem[0] >= $bgn);
			}
			close(LOGIN);
			$tmp =~ tr/\x0D\x0A//d;
			($count,$tmp) = split('<>',$tmp,2);
			if ($flag ne 'on') { # Ͽ
				unshift(@buf,"$gNowTime<>$env[1]<>$env[0]<>$env[2]<>$env[3]<>$gIn{'href'}<>$gIn{'refe'}<>\n");
				$count++ if ($tmp ne $env[1]);
				open(LOGOUT,">$file") or die($gMsg{'error'}{'file_open'} . $file);
				binmode(LOGOUT);
				print LOGOUT $count,'<>',$env[1],"\n";
				print LOGOUT @buf;
				close(LOGOUT);
			}
		};
		&sblock_unlock($lfile);
		die($@ . "\n") if ($@);
	}
	return($count);
}
sub sbcnt_httphead { # HTTP HEADɽ
	my $mode = shift; # ϥѥ᡼
	my ($out) = ();   # ϥѥ᡼
	$out .= 'Content-Type: text/javascript' . "\n" if ($mode eq 'js');
	$out .= 'Content-type: image/gif' . "\n" if ($mode eq 'gif');
	$out .= 'Content-Type: text/html' . "\n" if ($mode ne 'js' and $mode ne 'gif');
	$out .= 'Pragma: no-cache' . "\n";
	$out .= 'Cache-Control: no-store, no-cache, must-revalidate, post-check=0, pre-check=0' . "\n";
	$out .= 'Expires: ' . &sbtime_stamp($gNowTime - 100,'%wk, %Dy-%MO-%yr %hr:%mi:%sc GMT','+0000','en') . "\n";
	$out .= "\n"; # إåȥܥǥζڤ
	return($out);
}
sub sbcnt_readcookie { # åɹ
	my $name = shift; # ϥѥ᡼
	my (%eating,@cookies,%cookie_base) = (); # ѥ᡼
	@cookies = split(/;/,$ENV{'HTTP_COOKIE'});
	foreach (@cookies) {
		my ($cook_key,$cook_val) = split(/=/,$_);
		$cook_key =~ s/ //g;
		$cookie_base{$cook_key} = $cook_val;
	}
	@cookies = split(/,/,$cookie_base{$name});
	foreach (@cookies) {
		my ($cook_key,$cook_val) = split('<>',$_);
		$eating{$cook_key} = $cook_val;
	}
	return($eating{$name});
}
sub sbcnt_dispimage { # ߡ᡼
	my @dmy = (
		'47','49','46','38','39','61','02','00','02','00','80','00','00','00','00',
		'00','ff','ff','ff','21','f9','04','01','00','00','01','00','2c','00','00',
		'00','00','02','00','02','00','00','02','02','8c','53','00','3b'
	);
	binmode(STDOUT);
	foreach (@dmy) {
		my $data = pack('C*',hex($_));
		print $data;
	}
	return();
}
sub sbcnt_dispcount { # ɽ
	my $count = shift;
	print 'document.write("',$count,'");',"\n";
	return();
}
1;
